VERSION 5.00
Begin VB.Form frmMain 
   BackColor       =   &H80000005&
   Caption         =   "GDI+ Test"
   ClientHeight    =   5985
   ClientLeft      =   165
   ClientTop       =   735
   ClientWidth     =   7815
   LinkTopic       =   "GDIPlus Test"
   ScaleHeight     =   399
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   521
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox picGrapes 
      Height          =   915
      Left            =   3660
      ScaleHeight     =   855
      ScaleWidth      =   1095
      TabIndex        =   0
      Top             =   2580
      Visible         =   0   'False
      Width           =   1155
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuBar 
         Caption         =   "-"
      End
      Begin VB.Menu mnuExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuRedraw 
      Caption         =   "&Redraw Demo"
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
' Avery P. - 7/30/2002
' Examples are from the GDI+ portion of the Platform SDK


Dim token As Long ' Needed to close GDI+

Private Sub Form_Load()
   ' Load the GDI+ Dll
   Dim GpInput As GdiplusStartupInput
   GpInput.GdiplusVersion = 1
   If GdiplusStartup(token, GpInput) <> Ok Then
      MsgBox "Error loading GDI+!", vbCritical
      Unload Me
   End If
End Sub

Private Sub Form_Unload(Cancel As Integer)
   ' Unload the GDI+ Dll
   Call GdiplusShutdown(token)
End Sub

Private Sub mnuRedraw_Click()
   Cls   ' Clear the window

   ' Uncomment one to see it's demo
   'Call DrawCurves
   'Call DrawScaling
   'Call DrawSkewed
   'Call DrawTexturedLine
   'Call DrawLineCaps
   'Call DrawCustomDashed
   'Call DrawSolidShape
   'Call DrawHatchShape
   'Call DrawThumbnail     ' You'll need to change the image filename
   'Call DrawHorizGradient
   'Call DrawDiagGradient
   'Call DrawPathGradient
   'Call BMPtoPNG
   'Call BMPtoJPEG
   'Call BMPtoJPEG_Params
   'Call DrawCachedBitmap  ' WARNING: Running this with AutoRedraw = True is not a good idea!
   Call DrawAlphaLines
   'Call DrawColorMatrix
   'Call DrawAlphaPixels
   'Call DrawAntiAliasText
   'Call DrawFormatText
   'Call DrawRotated
End Sub

Private Sub mnuExit_Click()
   Unload Me
End Sub


'======================================================================
' THE SAMPLES!
'======================================================================
Private Sub DrawLineCaps()
   Dim graphics As Long, pen As Long
   
   ' Initializations
   Call GdipCreateFromHDC(Me.hdc, graphics)     ' Initialize the graphics class - required for all drawing
   Call GdipCreatePen1(Blue, 8, UnitPixel, pen)
   
   ' Set the start and end caps
   Call GdipSetPenStartCap(pen, LineCapArrowAnchor)
   Call GdipSetPenEndCap(pen, LineCapRoundAnchor)
   
   ' Draw the line
   Call GdipDrawLineI(graphics, pen, 20, 175, 300, 175)
   
   ' Cleanup
   Call GdipDeletePen(pen)
   Call GdipDeleteGraphics(graphics)
End Sub

Private Sub DrawCustomDashed()
   Dim graphics As Long, pen As Long
   Dim dashValues(1 To 4) As Single
   
   ' Set the dash intervals
   ' The dashes are in an on/off pattern and continually repeat for the length of the line
   dashValues(1) = 5    ' Show 5 * penwidth
   dashValues(2) = 2    ' Hide 2 * penwidth
   dashValues(3) = 15   ' Show 15 * penwidth
   dashValues(4) = 4    ' Hide 4 * pendwith

   ' Initializations
   Call GdipCreateFromHDC(Me.hdc, graphics)     ' Initialize the graphics class - required for all drawing
   Call GdipCreatePen1(Black, 4, UnitPixel, pen)
   
   ' Set the dash pattern
   Call GdipSetPenDashArray(pen, dashValues(1), 4)
   
   ' Draw the line
   Call GdipDrawLineI(graphics, pen, 5, 5, 405, 5)
   
   ' Cleanup
   Call GdipDeletePen(pen)
   Call GdipDeleteGraphics(graphics)
End Sub

Private Sub DrawTexturedLine()
   Dim graphics As Long, img As Long, pen As Long, tBrush As Long
   Dim lngHeight As Long, lngWidth As Long

   ' Initializations
   Call GdipCreateFromHDC(Me.hdc, graphics)     ' Initialize the graphics class - required for all drawing
   Call GdipLoadImageFromFile(StrConv("Texture.bmp", vbUnicode), img)
   Call GdipCreateTexture(img, WrapModeTile, tBrush) ' Create a textured brush
   Call GdipCreatePen2(tBrush, 30, UnitPixel, pen)  ' Create a pen to draw with

   ' Get the image height and width
   Call GdipGetImageHeight(img, lngHeight)
   Call GdipGetImageWidth(img, lngWidth)

   Call GdipDrawImageRect(graphics, img, 0, 0, lngWidth, lngHeight)
   Call GdipDrawEllipseI(graphics, pen, 100, 20, 200, 100)
   
   ' Cleanup
   Call GdipDeletePen(pen)
   Call GdipDeleteBrush(tBrush)
   Call GdipDisposeImage(img)
   Call GdipDeleteGraphics(graphics)
End Sub

Private Sub DrawSolidShape()
   Dim graphics As Long, brush As Long
   Dim lngHeight As Long, lngWidth As Long


   ' Initializations
   Call GdipCreateFromHDC(Me.hdc, graphics) ' Initialize the graphics class - required for all drawing
   Call GdipCreateSolidFill(DeepPink, brush)     ' Create the solid colored brush
   
   ' Draw an ellipse
   Call GdipFillEllipseI(graphics, brush, 0, 0, 100, 60)

   ' Cleanup
   Call GdipDeleteBrush(brush)
   Call GdipDeleteGraphics(graphics)
End Sub

Private Sub DrawHatchShape()
   Dim graphics As Long, brush As Long
   Dim lngHeight As Long, lngWidth As Long


   ' Initializations
   Call GdipCreateFromHDC(Me.hdc, graphics) ' Initialize the graphics class - required for all drawing
   Call GdipCreateHatchBrush(HatchStyleDottedGrid, Black, DeepPink, brush)      ' Create the pattern brush
   
   ' Draw an ellipse
   Call GdipFillEllipseI(graphics, brush, 0, 0, 100, 60)

   ' Cleanup
   Call GdipDeleteBrush(brush)
   Call GdipDeleteGraphics(graphics)
End Sub

Private Sub DrawCurves()
   Dim graphics As Long, pen As Long
   Dim points(1 To 5) As POINTL
   

   ' Random values (From the SDK C++ sample)
   points(1).x = 0
   points(1).y = 100
   points(2).x = 50
   points(2).y = 80
   points(3).x = 100
   points(3).y = 20
   points(4).x = 150
   points(4).y = 80
   points(5).x = 200
   points(5).y = 100

   ' Initializations
   Call GdipCreateFromHDC(Me.hdc, graphics)     ' Initialize the graphics class - required for all drawing
   Call GdipCreatePen1(Linen, 10, UnitPixel, pen)  ' Create a pen to draw with

   ' Gamma correction is nice, though slower...
   Call GdipSetCompositingQuality(graphics, CompositingQualityGammaCorrected)
   ' Draw the curve w/ anti-aliasing
   Call GdipSetSmoothingMode(graphics, SmoothingModeAntiAlias)
   Call GdipDrawCurveI(graphics, pen, points(1), 5)
   
   ' Cleanup
   Call GdipDeletePen(pen)
   Call GdipDeleteGraphics(graphics)
End Sub

Private Sub DrawScaling()
   ' Why did I store the picture in a hidden PictureBox, you ask?
   ' Well, I'll tell you why: To make the demo simple yet complex
   ' enough for you to figure out how to build on it. (I hate VERY
   ' simple demos, and you should too!) I hope this isn't too simple...
   Dim graphics As Long, img As Long
   Dim lngHeight As Long, lngWidth As Long
   
   
   ' We are going to draw on the form, hence the Me.hDC
   Call GdipCreateFromHDC(Me.hdc, graphics)  ' Initialize the graphics class - required for all drawing
   
   
   ' Load the bitmap file into the Picture box (could also embed it)
   Set picGrapes.Picture = LoadPicture("GrapeBunch.bmp")
   ' WARNING: Make sure the picture box is large enough - WSIWYG!
   picGrapes.AutoSize = True  ' This should do for what we need
   ' Get the image "class" from the PictureBox
   Call GdipCreateBitmapFromHBITMAP(picGrapes.image.Handle, picGrapes.image.hpal, img)
   ' Below is the "cheap" way (via file); good for all supported file type
   ' Could also use GdipCreateBitmapFromFile for this bitmap
   ' Comment out the picture box code above and uncomment this to try it out if you want!
   'Call GdipLoadImageFromFile(StrConv("GrapeBunch.bmp", vbUnicode), img)
   

   ' Get the image height and width
   Call GdipGetImageHeight(img, lngHeight)
   Call GdipGetImageWidth(img, lngWidth)
   
   '**** If you don't pass a width and height when drawing, the image is auto-scaled!! ****
   'Call GdipDrawImage(graphics, img, 10, 10) ' Auto-Scaled

   ' Draw the image with no shrinking or stretching
   Call GdipDrawImageRectI(graphics, img, 10, 10, lngWidth, lngHeight)
   
   ' Shrink the image using low-quality interpolation.
   Call GdipSetInterpolationMode(graphics, InterpolationModeNearestNeighbor)
   Call GdipDrawImageRectRectI(graphics, img, 10, 250, 0.6 * lngWidth, 0.6 * lngHeight, 0, 0, lngWidth, lngHeight, UnitPixel)
   
   ' Shrink the image using medium-quality interpolation.
   Call GdipSetInterpolationMode(graphics, InterpolationModeHighQualityBilinear)
   Call GdipDrawImageRectRectI(graphics, img, 150, 250, 0.6 * lngWidth, 0.6 * lngHeight, 0, 0, lngWidth, lngHeight, UnitPixel)
   
   ' Shrink the image using high-quality interpolation.
   Call GdipSetInterpolationMode(graphics, InterpolationModeHighQualityBicubic)
   Call GdipDrawImageRectRectI(graphics, img, 290, 250, 0.6 * lngWidth, 0.6 * lngHeight, 0, 0, lngWidth, lngHeight, UnitPixel)
   
   ' NOTES: Since we are shrinking the entire image, we could just as well have called
   '        the GdipDrawImageRectI function, which would simply things - but our goal must
   '        be make life hellish!
   
   ' Cleanup
   Call GdipDisposeImage(img) ' Delete the image
   Call GdipDeleteGraphics(graphics)
End Sub

Private Sub DrawSkewed()
   Dim graphics As Long, img As Long
   Dim destinationPoints(1 To 3) As POINTL
   Dim lngHeight As Long, lngWidth As Long


   ' Set the skewing points in the point array.
   ' destination for upper-left point of original
   destinationPoints(1).x = 200
   destinationPoints(1).y = 20
   ' destination for upper-right point of original
   destinationPoints(2).x = 110
   destinationPoints(2).y = 100
   ' destination for lower-left point of original
   destinationPoints(3).x = 250
   destinationPoints(3).y = 30

   ' Initializations
   Call GdipCreateFromHDC(Me.hdc, graphics) ' Initialize the graphics class - required for all drawing
   Call GdipLoadImageFromFile(StrConv("Stripes.bmp", vbUnicode), img)   ' Load the image

   ' Get the image height and width
   Call GdipGetImageHeight(img, lngHeight)
   Call GdipGetImageWidth(img, lngWidth)

   ' Draw the image unaltered with its upper-left corner at (0, 0).
   Call GdipDrawImageRectI(graphics, img, 0, 0, lngWidth, lngHeight)
   
   ' Draw the image mapped to the parallelogram.
   Call GdipDrawImagePointsI(graphics, img, destinationPoints(1), 3)
   
   ' Cleanup
   Call GdipDisposeImage(img) ' Delete the image
   Call GdipDeleteGraphics(graphics)
End Sub


Private Sub DrawThumbnail()
   Dim graphics As Long, img As Long, imgThumb As Long
   Dim lngHeight As Long, lngWidth As Long


   ' Initializations
   Call GdipCreateFromHDC(Me.hdc, graphics) ' Initialize the graphics class - required for all drawing
   Call GdipLoadImageFromFile(StrConv("SomeBigImage.bmp", vbUnicode), img)   ' Load the image

   ' Get the image height and width
   Call GdipGetImageHeight(img, lngHeight)
   Call GdipGetImageWidth(img, lngWidth)
   
   ' Create the thumbnail that is 100x100 in size
   Call GdipGetImageThumbnail(img, 100, 100, imgThumb)

   ' Draw the thumbnail image unaltered
   Call GdipDrawImageRectI(graphics, imgThumb, 10, 10, lngWidth, lngHeight)

   ' Cleanup
   Call GdipDisposeImage(img) ' Delete the image
   Call GdipDisposeImage(imgThumb) ' Delete the thumbnail image
   Call GdipDeleteGraphics(graphics)
End Sub

Private Sub DrawHorizGradient()
   Dim graphics As Long, brush As Long, pen As Long
   Dim pt1 As POINTL, pt2 As POINTL


   ' Set the gradient color points
   pt1.x = 0
   pt1.y = 10
   pt2.x = 200
   pt2.y = 10
   
   ' Initializations
   Call GdipCreateFromHDC(Me.hdc, graphics) ' Initialize the graphics class - required for all drawing
   ' Create the gradient brush; we'll use tiling
   Call GdipCreateLineBrushI(pt1, pt2, Red, Blue, WrapModeTile, brush)
   ' Create a pen with the same gradient brush
   Call GdipCreatePen2(brush, 1, UnitPixel, pen)
   
   ' Draw some objects
   Call GdipDrawLine(graphics, pen, 0, 10, 200, 10)
   Call GdipFillEllipse(graphics, brush, 0, 30, 200, 100)
   Call GdipFillRectangle(graphics, brush, 0, 155, 500, 30)

   'Cleanup
   Call GdipDeletePen(pen)
   Call GdipDeleteBrush(brush)
   Call GdipDeleteGraphics(graphics)
End Sub

Private Sub DrawDiagGradient()
   Dim graphics As Long, brush As Long, pen As Long
   Dim pt1 As POINTL, pt2 As POINTL

   ' Set the gradient color points
   ' pt1 will stay at 0,0
   pt2.x = 200
   pt2.y = 100
   
   ' Initializations
   Call GdipCreateFromHDC(Me.hdc, graphics) ' Initialize the graphics class - required for all drawing
   ' Create the gradient brush; we'll use tiling
   Call GdipCreateLineBrushI(pt1, pt2, LightGreen, LightBlue, WrapModeTile, brush)
   ' Create a pen with the same gradient brush
   Call GdipCreatePen2(brush, 10, UnitPixel, pen)
   
   ' Draw some objects
   Call GdipDrawLineI(graphics, pen, 0, 0, 600, 300)
   Call GdipFillEllipseI(graphics, brush, 10, 100, 200, 100)

   'Cleanup
   Call GdipDeletePen(pen)
   Call GdipDeleteBrush(brush)
   Call GdipDeleteGraphics(graphics)
End Sub

Private Sub DrawPathGradient()
   Dim graphics As Long, brush As Long, path As Long

   ' Initializations
   Call GdipCreateFromHDC(Me.hdc, graphics) ' Initialize the graphics class - required for all drawing
   ' Create a GraphicsPath object
   Call GdipCreatePath(FillModeAlternate, path)
   
   ' Add an ellipse to the path
   Call GdipAddPathEllipseI(path, 0, 0, 140, 70)
   
   ' Create a path gradient based on the ellipse
   Call GdipCreatePathGradientFromPath(path, brush)
   
   ' Set the middle color of the path to Blue
   Call GdipSetPathGradientCenterColor(brush, Blue)
   
   ' Set the entire path boundary to Aqua
   ' NOTE: This expects an array, but since we only have one item we can fudge it
   Call GdipSetPathGradientSurroundColorsWithCount(brush, Aqua, 1)
   
   ' Draw the ellipse, keeping the exact coords we defined for the path
   Call GdipFillEllipse(graphics, brush, 0, 0, 140, 70)
   
   'Cleanup
   Call GdipDeletePath(path)     ' Delete the path object
   Call GdipDeleteBrush(brush)
   Call GdipDeleteGraphics(graphics)
End Sub

' NOTE: Use this same concept for: BMP, GIF, and PNG format saving
Private Sub BMPtoPNG()
   Dim img As Long, encoderCLSID As CLSID
   Dim stat As GpStatus
   
   ' Initializations
   ' No graphics object needed here since we aren't doing any drawing.
   ' We'll convert the grapes bitmap file
   Call GdipLoadImageFromFile(StrConv("GrapeBunch.bmp", vbUnicode), img)
   
   ' Get the CLSID of the PNG encoder
   Call GetEncoderClsid("image/png", encoderCLSID)

   ' Save as a PNG file. There are no encoder parameters for PNG images, so we pass a NULL.
   ' NOTE: The NULL (aka 0) must be passed byval, as the function declaration would get a pointer to the number 0.
   stat = GdipSaveImageToFile(img, StrConv("GrapeBunch.png", vbUnicode), encoderCLSID, ByVal 0)
   
   ' See if it was created
   If stat = Ok Then
      MsgBox "Successfully saved GrapeBunch.png!", vbInformation
   Else
      MsgBox "Error saving file! Status Code: " & stat, vbCritical
   End If
   
   ' Cleanup
   Call GdipDisposeImage(img)
End Sub

' Note: Use this same concept for: JPEG and TIFF saving
Private Sub BMPtoJPEG()
   Dim img As Long, encoderCLSID As CLSID
   Dim stat As GpStatus
   Dim encoderParams As EncoderParameters

   ' Initializations
   ' No graphics object needed here since we aren't doing any drawing.
   ' We'll convert the grapes bitmap file
   Call GdipLoadImageFromFile(StrConv("GrapeBunch.bmp", vbUnicode), img)
   
   ' Get the CLSID of the PNG encoder
   Call GetEncoderClsid("image/jpeg", encoderCLSID)

   ' Save as a JPEG file. This format requires encoder parameters.
   ' Setup the encoder paramters
   encoderParams.count = 1    ' Only one element in this Parameter array
   With encoderParams.Parameter
      .NumberOfValues = 1     ' Should be one
      .type = EncoderParameterValueTypeLong
      ' Set the GUI to EncoderQuality
      Call GetParameterGUID(EncoderQuality, .GUID)
      .value = VarPtr(90)  ' Remember: The value expects only pointers!
   End With
   
   ' Now save the bitmap as a jpeg at 10% compression
   stat = GdipSaveImageToFile(img, StrConv("GrapeBunch.jpg", vbUnicode), encoderCLSID, encoderParams)

   ' See if it was created
   If stat = Ok Then
      MsgBox "Successfully saved GrapeBunch.jpg!", vbInformation
   Else
      MsgBox "Error saving file! Status Code: " & stat, vbCritical
   End If
   
   ' Cleanup
   Call GdipDisposeImage(img)
End Sub

' Now that we know how to set the value of one encoding parameter, what do we do if we
' want to set more than one encoding parameter? Well, this function will show you how to
' do it!
' Note: Requires the CopyMemory API
' >> NOTE: You can ONLY rotate JPEG images! If you load a NON-JPEG image and try to rotate, nothing will happen!
Private Sub BMPtoJPEG_Params()
   Dim img As Long, encoderCLSID As CLSID
   Dim stat As GpStatus
   Dim encoderParams As EncoderParameters ' This will now become a temporary holder
   Dim encoderArray() As Byte             ' Our main "struct"
   Dim lngEP As Long                        ' Size of encoderParams variable/struct

   ' Initializations
   ' No graphics object needed here since we aren't doing any drawing.
   ' We'll rotate the GrapeBunch.jpg file
   Call GdipLoadImageFromFile(StrConv("GrapeBunch.jpg", vbUnicode), img)
   lngEP = Len(encoderParams)
   
   ' Get the CLSID of the PNG encoder
   Call GetEncoderClsid("image/jpeg", encoderCLSID)

   ' Determine how many parameters we will need
   ' JPEGs can only use 2 parameters, so we'll use both
   ReDim encoderArray(0 To (lngEP + Len(encoderParams.Parameter))) As Byte

   ' Save as a JPEG file. This format requires encoder parameters.
   ' Setup the encoder paramters
   ' We'll setup the struct and first parameter as usual
   encoderParams.count = 2    ' We are setting 2 parameters
   With encoderParams.Parameter
      .NumberOfValues = 1     ' Should be one
      .type = EncoderParameterValueTypeLong
      ' Set the GUI to EncoderQuality
      Call GetParameterGUID(EncoderQuality, .GUID)
      .value = VarPtr(100)  ' Remember: The value expects only pointers!
   End With

   ' Copy the data into the byte array
   CopyMemory encoderArray(0), encoderParams, lngEP
   
   ' Now we'll re-use the parameter member of encoderParams
   With encoderParams.Parameter
      .NumberOfValues = 1     ' Should be one
      .type = EncoderParameterValueTypeLong
      ' Set the GUI to EncoderTransformation
      Call GetParameterGUID(EncoderTransformation, .GUID)
      ' We'll flip horizontally - REMEMBER TO USE A POINTER!
      .value = VarPtr(EncoderValueTransformRotate180)
   End With

   ' Copy the second parameter to the byte array at the right offset
   CopyMemory encoderArray(lngEP), encoderParams.Parameter, Len(encoderParams.Parameter)
   
   ' Now save the bitmap as a jpeg at 0% compression to try to keep the quality up
   ' Notice how the byte array is passed instead of the struct
   stat = GdipSaveImageToFile(img, StrConv("GrapeBunch180.jpg", vbUnicode), encoderCLSID, encoderArray(0))

   ' See if it was created
   If stat = Ok Then
      MsgBox "Successfully saved GrapeBunch.jpg!", vbInformation
   Else
      MsgBox "Error saving file! Status Code: " & stat, vbCritical
   End If
   
   ' Cleanup
   Call GdipDisposeImage(img)
End Sub

Private Sub DrawCachedBitmap()
   Dim graphics As Long, bitmap As Long, cBitmap As Long
   Dim lngHeight As Long, lngWidth As Long
   Dim j As Long, k As Long

   ' Initializations
   Call GdipCreateFromHDC(Me.hdc, graphics) ' Initialize the graphics class - required for all drawing
   Call GdipLoadImageFromFile(StrConv("Texture.bmp", vbUnicode), bitmap)   ' Load the image
   ' Create a cached bitmap from the loaded image
   Call GdipCreateCachedBitmap(bitmap, graphics, cBitmap)

   ' Get the image height and width
   Call GdipGetImageHeight(bitmap, lngHeight)
   Call GdipGetImageWidth(bitmap, lngWidth)
   
   ' Perform a test to see which is faster
   For j = 1 To 300 Step 10
      For k = 1 To 1000
         Call GdipDrawImageRect(graphics, bitmap, j, j / 2, lngWidth, lngHeight)
      Next
   Next
   
   For j = 1 To 300 Step 10
      For k = 1 To 1000
         Call GdipDrawCachedBitmap(graphics, cBitmap, j, 150 + j / 2)
      Next
   Next

   ' Cleanup
   Call GdipDisposeImage(bitmap)
   Call GdipDeleteCachedBitmap(cBitmap)   ' Note the special deletion function
   Call GdipDisposeImage(cBitmap)         ' This may not be needed...
   Call GdipDeleteGraphics(graphics)
End Sub

Private Sub DrawAlphaLines()
   Dim graphics As Long, bitmap As Long
   Dim lngHeight As Long, lngWidth As Long
   Dim opaquePen As Long, semiTansPen As Long

   ' Initializations
   Call GdipCreateFromHDC(Me.hdc, graphics) ' Initialize the graphics class - required for all drawing
   Call GdipLoadImageFromFile(StrConv("Texture.bmp", vbUnicode), bitmap)   ' Load the image
   ' Create our pens for line drawing
   Call GdipCreatePen1(ColorARGB(255, 0, 0, 255), 15, UnitPixel, opaquePen)
   Call GdipCreatePen1(ColorARGB(128, 0, 0, 255), 15, UnitPixel, semiTansPen) ' Has 50% alpha blending

   ' Get the image height and width
   Call GdipGetImageHeight(bitmap, lngHeight)
   Call GdipGetImageWidth(bitmap, lngWidth)

   ' Draw the image without auto-scaling
   Call GdipDrawImageRect(graphics, bitmap, 10, 5, lngWidth, lngHeight)
   
   ' Draw an opaque line over the image
   Call GdipDrawLine(graphics, opaquePen, 0, 20, 100, 20)
   ' Draw the semi-transparent line over the image
   Call GdipDrawLine(graphics, semiTansPen, 0, 40, 100, 40)
   ' Draw the same semi-transparent line, but with gamma correction
   Call GdipSetCompositingQuality(graphics, CompositingQualityGammaCorrected)
   Call GdipDrawLine(graphics, semiTansPen, 0, 60, 100, 60)
   
   ' Cleanup
   Call GdipDeletePen(opaquePen)
   Call GdipDeletePen(semiTansPen)
   Call GdipDisposeImage(bitmap)
   Call GdipDeleteGraphics(graphics)
End Sub

Private Sub DrawColorMatrix()
   Dim graphics As Long, bitmap As Long, pen As Long
   Dim imgAttr As Long, clrMatrix As ColorMatrix
   Dim lngHeight As Long, lngWidth As Long
   
   
   ' Initializations
   Call GdipCreateFromHDC(Me.hdc, graphics) ' Initialize the graphics class - required for all drawing
   Call GdipLoadImageFromFile(StrConv("Texture.bmp", vbUnicode), bitmap)   ' Load the image
   Call GdipCreatePen1(Black, 15, UnitPixel, pen)  ' Create an opaque pen

   ' Get the image height and width
   Call GdipGetImageHeight(bitmap, lngHeight)
   Call GdipGetImageWidth(bitmap, lngWidth)

   ' Fill the color matrix
   ' Notice the value 0.8 in row 4, column 4.
   clrMatrix.m(0, 0) = 1: clrMatrix.m(1, 0) = 0: clrMatrix.m(2, 0) = 0: clrMatrix.m(3, 0) = 0: clrMatrix.m(4, 0) = 0
   clrMatrix.m(0, 1) = 0: clrMatrix.m(1, 1) = 1: clrMatrix.m(2, 1) = 0: clrMatrix.m(3, 1) = 0: clrMatrix.m(4, 1) = 0
   clrMatrix.m(0, 2) = 0: clrMatrix.m(1, 2) = 0: clrMatrix.m(2, 2) = 1: clrMatrix.m(3, 2) = 0: clrMatrix.m(4, 2) = 0
   clrMatrix.m(0, 3) = 0: clrMatrix.m(1, 3) = 0: clrMatrix.m(2, 3) = 0: clrMatrix.m(3, 3) = 0.8: clrMatrix.m(4, 3) = 0
   clrMatrix.m(0, 4) = 0: clrMatrix.m(1, 4) = 0: clrMatrix.m(2, 4) = 0: clrMatrix.m(3, 4) = 0: clrMatrix.m(4, 4) = 1

   ' Create the ImageAttributes object
   Call GdipCreateImageAttributes(imgAttr)
   ' And set its color matrix
   Call GdipSetImageAttributesColorMatrix(imgAttr, ColorAdjustTypeDefault, True, clrMatrix, ByVal 0, ColorMatrixFlagsDefault)

   ' Draw a wide black line
   Call GdipDrawLine(graphics, pen, 10, 35, 200, 35)
   
   ' Draw the semi-transparent image
   Call GdipDrawImageRectRectI(graphics, bitmap, 30, 0, lngWidth, lngHeight, 0, 0, lngWidth, lngHeight, UnitPixel, imgAttr)

   ' Cleanup
   Call GdipDisposeImageAttributes(imgAttr)  ' Delete the Image attributes object
   Call GdipDeletePen(pen)
   Call GdipDisposeImage(bitmap)
   Call GdipDeleteGraphics(graphics)
End Sub

' The slower way of using alpha-blending
Private Sub DrawAlphaPixels()
   Dim graphics As Long, bitmap As Long, pen As Long
   Dim lngHeight As Long, lngWidth As Long
   Dim iRow As Long, iCol As Long, lARGB As Long
   
   
   ' Initializations
   Call GdipCreateFromHDC(Me.hdc, graphics) ' Initialize the graphics class - required for all drawing
   Call GdipLoadImageFromFile(StrConv("Texture.bmp", vbUnicode), bitmap)   ' Load the image
   Call GdipCreatePen1(Black, 15, UnitPixel, pen)  ' Create an opaque pen

   ' Get the image height and width
   Call GdipGetImageHeight(bitmap, lngHeight)
   Call GdipGetImageWidth(bitmap, lngWidth)

   ' Modify the pixels in the bitmap
   ' NOTE: I'm pretty sure that the bitmap object it forever modified by doing this.
   '       If you still want the original, I would suggest cloning this image first.
   For iRow = 0 To (lngHeight - 1)
      For iCol = 0 To (lngWidth - 1)
         ' Get the current ARGB color of the pixel
         Call GdipBitmapGetPixel(bitmap, iCol, iRow, lARGB)
         ' Set the pixel color back with a new alpha
         ' NOTE: I created a helper function for alpha setting to make it easier
         Call GdipBitmapSetPixel(bitmap, iCol, iRow, ColorSetAlpha(lARGB, 255 * iCol / lngWidth))
      Next
   Next

   ' Draw a wide black line
   Call GdipDrawLine(graphics, pen, 10, 35, 200, 35)
   
   ' Draw the modified image
   Call GdipDrawImageRect(graphics, bitmap, 30, 0, lngWidth, lngHeight)
   

   ' Cleanup
   Call GdipDeletePen(pen)
   Call GdipDisposeImage(bitmap)
   Call GdipDeleteGraphics(graphics)
End Sub

Private Sub DrawAntiAliasText()
   Dim graphics As Long, brush As Long
   Dim fontFam As Long, curFont As Long
   Dim rcLayout As RECTF   ' Designates the string drawing bounds
   
   ' Initializations
   Call GdipCreateFromHDC(Me.hdc, graphics) ' Initialize the graphics class - required for all drawing
   Call GdipCreateSolidFill(Blue, brush)    ' Create a brush to draw the text with
   ' Create a font family object to allow use to create a font
   ' We have no font collection here, so pass a NULL for that parameter
   Call GdipCreateFontFamilyFromName(StrConv("Times New Roman", vbUnicode), 0, fontFam)
   ' Create the font from the specified font family name
   Call GdipCreateFont(fontFam, 32, FontStyleRegular, UnitPixel, curFont)
   
   ' Set up a drawing area
   ' NOTE: Leaving the right and bottom values at zero means there is no boundary
   rcLayout.Left = 10
   rcLayout.Top = 10
   
   ' This function allows us to alter the text quality.
   ' We'll use the worst quality first.
   Call GdipSetTextRenderingHint(graphics, TextRenderingHintSingleBitPerPixel)
   ' We have no string format object, so pass a NULL for that parameter
   Call GdipDrawString(graphics, StrConv("SingleBitPerPixel", vbUnicode), 17, curFont, rcLayout, 0, brush)
   
   
   ' Set up another drawing area
   rcLayout.Left = 10
   rcLayout.Top = 60
   
   ' Now we'll use anti-aliasing
   Call GdipSetTextRenderingHint(graphics, TextRenderingHintAntiAlias)
   ' We have no string format object, so pass a NULL for that parameter
   Call GdipDrawString(graphics, StrConv("AntiAlias", vbUnicode), 9, curFont, rcLayout, 0, brush)
   
   
   ' Cleanup
   Call GdipDeleteFont(curFont)     ' Delete the font object
   Call GdipDeleteFontFamily(fontFam)  ' Delete the font family object
   Call GdipDeleteBrush(brush)
   Call GdipDeleteGraphics(graphics)
End Sub

Private Sub DrawFormatText()
   Dim graphics As Long, brush As Long, pen As Long
   Dim fontFam As Long, curFont As Long, strFormat As Long
   Dim rcLayout As RECTF   ' Designates the string drawing bounds
   Dim str As String
   
   ' Initializations
   Call GdipCreateFromHDC(Me.hdc, graphics) ' Initialize the graphics class - required for all drawing
   Call GdipCreateSolidFill(Blue, brush)    ' Create a brush to draw the text with
   ' Create a font family object to allow use to create a font
   ' We have no font collection here, so pass a NULL for that parameter
   Call GdipCreateFontFamilyFromName(StrConv("Arial", vbUnicode), 0, fontFam)
   ' Create the font from the specified font family name
   ' >> Note that we have changed the drawing Unit from pixels to points!!
   Call GdipCreateFont(fontFam, 12, FontStyleUnderline + FontStyleBoldItalic, UnitPoint, curFont)
   ' Create the StringFormat object
   ' We can pass NULL for the flags and language id if we want
   Call GdipCreateStringFormat(0, 0, strFormat)
   
   ' Set up the drawing area boundary
   rcLayout.Left = 30
   rcLayout.Top = 10
   rcLayout.Right = 120
   rcLayout.Bottom = 140
   
   ' Center-justify each line of text
   Call GdipSetStringFormatAlign(strFormat, StringAlignmentCenter)
   
   ' Center the block of text (top to bottom) in the rectangle.
   Call GdipSetStringFormatLineAlign(strFormat, StringAlignmentCenter)
   
   ' Draw the string within the boundary
   str = StrConv("Use StringFormat and RectF objects to center text in a rectangle.", vbUnicode)
   Call GdipDrawString(graphics, str, -1, curFont, rcLayout, strFormat, brush)
   
   ' Create a pen and draw the boundary around the text
   Call GdipCreatePen1(Black, 1, UnitPixel, pen)
   Call GdipDrawRectangles(graphics, pen, rcLayout, 1)
   
   ' Cleanup
   Call GdipDeletePen(pen)
   Call GdipDeleteStringFormat(strFormat)
   Call GdipDeleteFont(curFont)     ' Delete the font object
   Call GdipDeleteFontFamily(fontFam)  ' Delete the font family object
   Call GdipDeleteBrush(brush)
   Call GdipDeleteGraphics(graphics)
End Sub

' Note: This example was inspired by another post on planetsourcecode today.
'       Someone asked if GDI+ could rotate images with anti-alias, and behold!
Private Sub DrawRotated()
   Dim graphics As Long, img As Long, pen As Long
   Dim lngHeight As Long, lngWidth As Long
   
   ' Initializations
   Call GdipCreateFromHDC(Me.hdc, graphics) ' Initialize the graphics class - required for all drawing
   Call GdipLoadImageFromFile(StrConv("GrapeBunch.bmp", vbUnicode), img)

   ' Get the image height and width
   Call GdipGetImageHeight(img, lngHeight)
   Call GdipGetImageWidth(img, lngWidth)

   ' This will rotate EVERYTHING!
   ' There are several rotation APIs available for you!
   Call GdipRotateWorldTransform(graphics, 45, MatrixOrderAppend)
   
   ' Make sure to provide a good x,y starting point!
   Call GdipDrawImageRect(graphics, img, 200, -150, lngWidth, lngHeight)

   ' Cleanup
   Call GdipDisposeImage(img)
   Call GdipDeleteGraphics(graphics)
End Sub
